﻿package jp.strippers.remoting {

  import flash.net.NetConnection;
  import flash.net.ObjectEncoding;
  import flash.events.NetStatusEvent;

  public class RemotingConnection extends NetConnection {

    public function RemotingConnection(gatewayUrl:String, objectEncoding:uint=ObjectEncoding.AMF3) {
      this.objectEncoding = objectEncoding;
      addEventListener(NetStatusEvent.NET_STATUS, netStatusHandler);
      if (gatewayUrl) {
        connect(gatewayUrl);
      }
    }

    public function get gatewayUrl():String {
      return uri;
    }

    private function netStatusHandler(event:NetStatusEvent):void {
      dispatchEvent(event);
    }


    public function setCredentials(username:String, password:String):void {
      if (objectEncoding == ObjectEncoding.AMF0) {
        addHeader("Credentials", false, {userid: username, password: password});
	  } else {
        addHeader("credentialsUsername", false, username);
	    addHeader("credentialsPassword", false, password);
	  }
    }

  }
}
